// Demo_SLE4442.cpp : Defines the entry point for the application.
//

#include <windows.h>
#include "stdio.h"
#include "conio.h"

#include "Demo_SLE4442.h"

//Include header and LIBs
#include "InfSmart.h"
#pragma comment( lib, "InfSmart.lib" )

#include "InfUnltd.h"
#pragma comment( lib, "InfUnltd.lib" )

unsigned char DEVICE = 0;

#define INFUNLTD 1
#define INFSMART 2

//Map IO functions to either InfSmart or InfUnltd
int SynchronousBegin(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousBegin(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousBegin(hDevice);

	return 1;
}

int SynchronousEnd(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousEnd(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousEnd(hDevice);

	return 1;
}

int SynchronousProcess(HANDLE hDevice, unsigned char iostate)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousProcess(hDevice,iostate);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousProcess(hDevice,iostate);

	return 1;
}

int SynchronousWriteCommand(HANDLE hDevice, unsigned char control, unsigned char adr, unsigned char data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousWriteCommand(hDevice, control, adr, data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousWriteCommand(hDevice, control, adr, data);

	return 1;
}

int SynchronousWriteOneByteLSB(HANDLE hDevice, unsigned char data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousWriteOneByteLSB(hDevice, data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousWriteOneByteLSB(hDevice, data);

	return 1;
}

int SynchronousWriteOneByteMSB(HANDLE hDevice, unsigned char data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousWriteOneByteMSB(hDevice, data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousWriteOneByteMSB(hDevice, data);

	return 1;
}

int SynchronousCycleClock(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousCycleClock(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousCycleClock(hDevice);

	return 1;
}

int SynchronousRead8bit(HANDLE hDevice,unsigned char count, unsigned char* data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousRead8bit(hDevice,count,data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousRead8bit(hDevice,count,data);

	return 1;
}

int SynchronousReadXbytesYbits(HANDLE hDevice,unsigned char bytecount, unsigned char bitcount, unsigned char* data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousReadXbytesYbits(hDevice,bytecount, bitcount, data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousReadXbytesYbits(hDevice,bytecount, bitcount, data);

	return 1;
}

int SynchronousSetRST(HANDLE hDevice, unsigned char state)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousSetRST(hDevice, state);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousSetRST(hDevice, state);

	return 1;
}

int IICClockOutStart(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockOutStart(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockOutStart(hDevice);

	return 1;
}

int IICClockOutStop(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockOutStop(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockOutStop(hDevice);

	return 1;
}

int IICClockOutByte(HANDLE hDevice, unsigned char data)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockOutByte(hDevice,data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockOutByte(hDevice,data);

	return 1;
}

int IICClockInByteAck(HANDLE hDevice, unsigned char *data)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockInByteAck(hDevice,data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockInByteAck(hDevice,data);

	return 1;
}

int IICClockInByteNack(HANDLE hDevice, unsigned char *data)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockInByteNack(hDevice,data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockInByteNack(hDevice,data);

	return 1;
}

int IICCycleClock(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICCycleClock(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICCycleClock(hDevice);

	return 1;
}

HINSTANCE hInst = 0;
HWND m_MainDlg = 0;
INT_PTR CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

unsigned char atr[4];
unsigned char mainmemory[256];
unsigned char psc[4];
unsigned char protectedmemory[32];

int ReadMemory(HWND hDlg);

bool loggedin = false;

HANDLE hDevice = 0;

BOOL APIENTRY WinMain(HINSTANCE hinstCurrent,HINSTANCE hinstPrevious,LPSTR lpszCmdLine,int nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	hInst = hinstCurrent;

	m_MainDlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG1),0,(DLGPROC)MainDlgProc);

	ShowWindow(m_MainDlg,SW_SHOW);

	hAccelTable = LoadAccelerators(hinstCurrent, MAKEINTRESOURCE(IDC_DEMO_SLE4442));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	if(hDevice != 0)
	{
		SynchronousEnd(hDevice);

		if(DEVICE == INFUNLTD)
		INFUNLTD_CloseDevice(hDevice);
		else
		if(DEVICE == INFSMART)
		INFSMART_CloseDevice(hDevice);
	}

	return (int) msg.wParam;
}

unsigned char HexToChar(unsigned char MSB,unsigned char LSB)
{
	unsigned char Bin=0;

	if(LSB>=48 && LSB<=57) Bin=LSB-48;
    else if(LSB>= 65 && LSB<=70) Bin=LSB-55;
	else if(LSB>= 65 && LSB<=70) Bin=LSB-55;
	else if(LSB>= 97 && LSB<=102) Bin=LSB-87;

    if(MSB>=48 && MSB<=57) Bin+=(MSB-48)*16;
	else if(MSB>=65 && MSB<=70) Bin+=(MSB-55)*16;
	else if(MSB>= 97 && MSB<=102) Bin+=(MSB-87)*16;

	return Bin;
}

int OnInitDialog(HWND hDlg)
{
	int status = 1;

	for(int l = 0; l < 256; l++)
	{
		char buf[255] = {0};

		sprintf(buf,"%d",l);

		SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) buf);
	}

	for(int l = 0; l < 32; l++)
	{
		char buf[255] = {0};

		sprintf(buf,"%d",l);

		SendDlgItemMessage(hDlg,IDC_COMBO2,CB_ADDSTRING,0,(LPARAM) buf);
	}

	SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,(WPARAM) 0,(LPARAM) 0);
	SendDlgItemMessage(hDlg,IDC_COMBO2,CB_SETCURSEL,(WPARAM) 0,(LPARAM) 0);

	SetWindowText(GetDlgItem(hDlg,IDC_EDIT_PSC1),"FFFFFF");

	DWORD InfSmartDeviceCount = 0;

	INFSMART_GetNumDevices(&InfSmartDeviceCount);

	DWORD InfUnltdDeviceCount = 0;

	INFUNLTD_GetNumDevices(&InfUnltdDeviceCount);

	if(InfSmartDeviceCount > 0 && InfUnltdDeviceCount == 0)
	{
		status = INFSMART_OpenDeviceFromNum(0,&hDevice,0);
		DEVICE = INFSMART;
	}else
	if(InfSmartDeviceCount == 0 && InfUnltdDeviceCount > 0)
	{
		status = INFUNLTD_OpenDeviceFromNum(0,&hDevice,0);

		if(INFUNLTD_GetFirmwareVersion(hDevice) < 1050)
		{
			INFUNLTD_CloseDevice(hDevice);
			MessageBox(m_MainDlg,"Firmware version 1.05 required\n\nUpgrade using Infinity USB Unlimited software","Error",MB_OK);
			return 1;
		}

		INFUNLTD_SetTimeouts(2500,2500);

		DEVICE = INFUNLTD;
	}else
	if(InfSmartDeviceCount > 0 && InfUnltdDeviceCount > 0)
	{
		status = INFUNLTD_OpenDeviceFromNum(0,&hDevice,0);

		if(INFUNLTD_GetFirmwareVersion(hDevice) < 1050)
		{
			INFUNLTD_CloseDevice(hDevice);
			MessageBox(m_MainDlg,"Firmware version 1.05 required\n\nUpgrade using Infinity USB Unlimited software","Error",MB_OK);
			return 1;
		}

		INFUNLTD_SetTimeouts(2500,2500);

		DEVICE = INFUNLTD;
	}
	else status = 1;

	return status;
}

int OnWriteMemory(HWND hDlg)
{
	int status = 0;
	unsigned char adr = (unsigned char) SendMessage(GetDlgItem(hDlg,IDC_COMBO1),CB_GETCURSEL,0,0);
	unsigned char _val[3] = {0};
	unsigned char val = 0;

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Writing...");

	GetWindowText(GetDlgItem(hDlg,IDC_EDIT1),(char*)_val,3);

	val = HexToChar(_val[0],_val[1]);

	mainmemory[adr] = val;

	//Write memory
	status = SynchronousWriteCommand(hDevice,0x38,adr,val);
	status = SynchronousProcess(hDevice,1);
	
	//Verify
	::ReadMemory(hDlg);

	if(mainmemory[adr] == val)
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Written OK");
	else
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Write error");

	return 0;
}

int OnWriteProtectionMemory(HWND hDlg)
{
	int status = 0;
	unsigned char adr = (unsigned char) SendMessage(GetDlgItem(hDlg,IDC_COMBO2),CB_GETCURSEL,0,0);
	unsigned char _val[3] = {0};
	unsigned char val = 0;

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Writing...");

	val = mainmemory[adr];

	//Write memory
	status = SynchronousWriteCommand(hDevice,0x3C,adr,val);
	status = SynchronousProcess(hDevice,1);

	//Verify
	::ReadMemory(hDlg);

	unsigned char byteindex = 0;
	unsigned char bitindex = 0;

	byteindex = (int)(adr / 8);
	bitindex = (int)(adr % 8);

	

	if((protectedmemory[byteindex] & 1<<bitindex ? 1:0) == 0)
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Written OK");
	else
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Write error");

	return 0;
}

int OnWritePSC(HWND hDlg)
{
	int status = 0;
	unsigned char enteredpsc[3] = {0};
	unsigned char enteredpsc_ascii[7] = {0};
	unsigned char trycnt = 0;

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Writing...");

	GetWindowText(GetDlgItem(hDlg,IDC_EDIT_PSC1),(char*)enteredpsc_ascii,7);

	enteredpsc[0] = HexToChar(enteredpsc_ascii[0],enteredpsc_ascii[1]);
	enteredpsc[1] = HexToChar(enteredpsc_ascii[2],enteredpsc_ascii[3]);
	enteredpsc[2] = HexToChar(enteredpsc_ascii[4],enteredpsc_ascii[5]);

	trycnt = psc[0];

	if(trycnt & 0x01)
		trycnt &= ~0x01;
	else
	if(trycnt & 0x02)
		trycnt &= ~0x02;
	else
	if(trycnt & 0x04)
		trycnt &= ~0x04;

	//Write Error counter
	status = SynchronousWriteCommand(hDevice,0x39,0x00,trycnt);
	status = SynchronousProcess(hDevice,1);

	//Compare PSC1
	status = SynchronousWriteCommand(hDevice,0x33,0x01,enteredpsc[0]);
	status = SynchronousProcess(hDevice,1);

	//Compare PSC2
	status = SynchronousWriteCommand(hDevice,0x33,0x02,enteredpsc[1]);
	status = SynchronousProcess(hDevice,1);

	//Compare PSC3
	status = SynchronousWriteCommand(hDevice,0x33,0x03,enteredpsc[2]);
	status = SynchronousProcess(hDevice,1);

	//Reset Error counter
	status = SynchronousWriteCommand(hDevice,0x39,0x00,0xFF);
	status = SynchronousProcess(hDevice,1);

	//Read Error counter
	status = SynchronousWriteCommand(hDevice,0x31,0x00,0x00);
	status = SynchronousRead8bit(hDevice,4,psc);

	if(psc[0] == 0x07)
		status = 0;
	else status = 1;

	return status;
}

int OnChangePSC(HWND hDlg)
{
	int status = 0;
	unsigned char enteredpsc[3] = {0};
	unsigned char enteredpsc_ascii[7] = {0};

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Writing...");

	GetWindowText(GetDlgItem(hDlg,IDC_EDIT_PSC1),(char*)enteredpsc_ascii,7);

	enteredpsc[0] = HexToChar(enteredpsc_ascii[0],enteredpsc_ascii[1]);
	enteredpsc[1] = HexToChar(enteredpsc_ascii[2],enteredpsc_ascii[3]);
	enteredpsc[2] = HexToChar(enteredpsc_ascii[4],enteredpsc_ascii[5]);

	//Write new PSC
	status = SynchronousWriteCommand(hDevice,0x39,0x01,enteredpsc[0]);
	status = SynchronousProcess(hDevice,1);

	status = SynchronousWriteCommand(hDevice,0x39,0x02,enteredpsc[1]);
	status = SynchronousProcess(hDevice,1);

	status = SynchronousWriteCommand(hDevice,0x39,0x03,enteredpsc[2]);
	status = SynchronousProcess(hDevice,1);

	return status;
}

int ReadMemory(HWND hDlg)
{
	int status = 0;

	loggedin = false;

	memset(mainmemory,0,sizeof(mainmemory));
	memset(psc,0,sizeof(psc));

	//Send Read memory command, and read 256bytes
	status = SynchronousWriteCommand(hDevice,0x30,0x00,0x00);
	status = SynchronousRead8bit(hDevice,128,mainmemory + 0);
	status = SynchronousRead8bit(hDevice,128,mainmemory + 128);

	//Send Read PSC memory command, 4bytes
	status = SynchronousWriteCommand(hDevice,0x31,0x00,0x00);
	status = SynchronousRead8bit(hDevice,4,psc);

	//Send Read PSC memory command, 4bytes
	status = SynchronousWriteCommand(hDevice,0x34,0x00,0x00);
	status = SynchronousRead8bit(hDevice,4,protectedmemory);

	return status;
}

int OnReadMemory(HWND hDlg)
{
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON4),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON2),FALSE);
	SetWindowText(GetDlgItem(hDlg,IDC_BUTTON4),"Write PSC (Login)");
	
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Reading...");

	char buf[255] = {0};

	int status = 0;

	memset(atr,0,sizeof(atr));

	//Reset card and read ATR 4bytes
	status = SynchronousEnd(hDevice);
	Sleep(100);
	status = SynchronousBegin(hDevice);
	status = SynchronousRead8bit(hDevice,4,atr);

	::ReadMemory(hDlg);

	sprintf(buf,"Card reset (ATR = 0x%.2X%.2X%.2X%.2X, Error counter = 0x%.2X)",atr[0],atr[1],atr[2],atr[3],psc[0]);
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),buf);

	SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,(WPARAM) 0,(LPARAM) 0);
	sprintf(buf,"%.2X",mainmemory[0]);
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT1),buf);

	SendDlgItemMessage(hDlg,IDC_COMBO2,CB_SETCURSEL,(WPARAM) 0,(LPARAM) 0);
	sprintf(buf,"%d",protectedmemory[0] & 1<<0 ? 1:0);
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT2),buf);

	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON4),TRUE);

	return 0;
}

INT_PTR CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		{
			int res = OnInitDialog(hDlg);
			if(res == 0)
			{
				if(DEVICE == INFUNLTD)
				SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Connected to Infinity USB Unlimited");
				else
				if(DEVICE == INFSMART)
				SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Connected to Infinity USB Smart");
			}
			return (INT_PTR)TRUE;
		}

	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
			case CBN_SELCHANGE:
			{
				if(LOWORD(wParam)==IDC_COMBO1)
				{
					int CurrentSel = SendMessage(GetDlgItem(hDlg,IDC_COMBO1),CB_GETCURSEL,0,0);
					char buf[255] = {0};

					if(CurrentSel > -1)
					{
						sprintf(buf,"%.2X",mainmemory[CurrentSel]);
						SetWindowText(GetDlgItem(hDlg,IDC_EDIT1),buf);
					}
				}
				if(LOWORD(wParam)==IDC_COMBO2)
				{
					int CurrentSel = SendMessage(GetDlgItem(hDlg,IDC_COMBO2),CB_GETCURSEL,0,0);
					char buf[255] = {0};

					unsigned char byteindex = 0;
					unsigned char bitindex = 0;

					byteindex = (int)(CurrentSel / 8);
					bitindex = (int)(CurrentSel % 8);

					if(CurrentSel > -1)
					{
						sprintf(buf,"%d",protectedmemory[byteindex] & 1<<bitindex ? 1:0);
						SetWindowText(GetDlgItem(hDlg,IDC_EDIT2),buf);
					}
				}
			}
			break;
		}
		
		switch(LOWORD(wParam))
		{
			case IDOK:
			{
				return (INT_PTR)TRUE;
				break;
			}
	
			case IDCANCEL:
			{
				PostQuitMessage(0);
				break;
			}

			case IDC_BUTTON1:
				OnWriteMemory(hDlg);
				break;

			case IDC_BUTTON2:
				{
					unsigned int adr = (unsigned char) SendMessage(GetDlgItem(hDlg,IDC_COMBO2),CB_GETCURSEL,0,0);
					unsigned char _val[3] = {0};
					unsigned char val = 0;
					
					char buf[255];
					sprintf(buf,"Are you sure you want to permanently protect-write location %d with value 0x%.2X?\n\nThe action is irreversible!",adr,mainmemory[adr]);
					if(MessageBox(hDlg,buf,"Warning!",MB_YESNO) == IDYES)
					OnWriteProtectionMemory(hDlg);
				}
				break;

			case IDC_BUTTON3:
				OnReadMemory(hDlg);
				break;

			case IDC_BUTTON4:
				{
					int res = 0;
					
					
					if(loggedin)
					{
						res = OnChangePSC(hDlg);

						if(res == 0)
							SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"PSC Changed");
						else SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"PSC not changed");
					}

					if(!loggedin)
					{
					res = OnWritePSC(hDlg);

					if(res == 0)
					{
						SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Login OK");

						EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_BUTTON2),TRUE);
						SetWindowText(GetDlgItem(hDlg,IDC_BUTTON4),"Change PSC code");

						loggedin = true;
					}
					else
					{
						char buf[255] = {0};

						int tries = 0;

						if(psc[0] & 0x04)
							tries ++;

						if(psc[0] & 0x02)
							tries ++;

						if(psc[0] & 0x01)
							tries ++;

						sprintf(buf,"Login failed (%d tries left)",tries);
						SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),buf);
					}
					}
				}
				break;

		}
	break;

	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
