#pragma once

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>

#define ARRAY_SIZE 65536

class HexToBin
{
public:
	HexToBin(void);
	~HexToBin(void);
	int ParseHex(char szFile[],int iType);
	int ParseBin(char szFile[],int iType);
	int SaveBin(char szFile[]);
	unsigned char HexToChar(unsigned char MSB,unsigned char LSB);

	bool HexToBin::PrepareForBinInput(unsigned int Low, unsigned int High);
	int HexToBin::InputBin(unsigned char data);
	unsigned char HexToBin::OutputBin(unsigned int Index);
	void HexToBin::ClearBuffers(unsigned char val);
	unsigned int HexToBin::DataSize();

	bool BitData[ARRAY_SIZE];

	bool BIN,HEX;
	bool CRD;
	unsigned int LowAdr, HighAdr;
    
	HexToBin& HexToBin::operator=(const HexToBin& src);

	unsigned char* BinData;

private:
	unsigned int Size;
	WORD GetExtendedAddress(char str[]);
	WORD wFuses;
};
